LeetCode#413 Arithmetic Slices

[Description]:

A sequence of number is called arithmetic if it consists of at least three elements and if the difference between any two consecutive elements is the same.

For example, these are arithmetic sequence:

1, 3, 5, 7, 9
7, 7, 7, 7
3, -1, -5, -9

The following sequence is not arithmetic.

1, 1, 2, 5, 7

A zero-indexed array A consisting of N numbers is given. A slice of that array is any pair of integers (P, Q) such that 0 <= P < Q < N.

A slice (P, Q) of array A is called arithmetic if the sequence:
A[P], A[p + 1], ..., A[Q - 1], A[Q] is arithmetic. In particular, this means that P + 1 < Q.

The function should return the number of arithmetic slices in the array A.


Example:

A = [1, 2, 3, 4]

return: 3, for 3 arithmetic slices in A: [1, 2, 3], [2, 3, 4] and [1, 2, 3, 4] itself.

[题解]:

给出一组数字,找到其中前后差值相同的连续子序列的个数。

也是一道动态规划的题,他的规律是,如果A[n]-A[n-1]等于A[n-1]-A[n-2],那么在这里至少可以形成一个等差子序列。可以把这位置的子序列的个数看做是以这个位置为结尾的子序列的个数,因为这个位置比前一个位置多一个数字,所以子序列的个数也多了一个。(说的很不通顺的一段话,我尽力了)

因此!

转移方程就是在这里形成等差子序列的时候f[n] = f[n-1]+1。总数等于f[n]之和。

[Solution]:

class Solution {
public:
    int numberOfArithmeticSlices(vector<int>& A) {
        int l = A.size();
        if (l == 0) return 0;
        int res = 0;
        int dp[l] = {0};
       // if (A[1]-A[0]) dp[1] = 1;
        for (int i = 2; i < l; i++) {
        	if (A[i]-A[i-1] == A[i-1]-A[i-2]) {
        		dp[i] = dp[i-1]+1;
        	}
        	res +=dp[i];
        }
        return res;
    }
};

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值